// Prevent dropzone to search for upload elements
// WARNING : strict mode has to be removed on IE 11 dropzone.js file to avoid js errors
Dropzone.autoDiscover = false;
!(function ($) {

  var isUnloadBinded = false;
  var EXPLORER_UPLOADER;
  var tempUploaders = [];
  const dropzoneCommonParams = {
    url: "plugins/ExplorerPlugin/jsp/action/handleExplorerAction.jsp",
    paramName: "documents",
    clickable: false,
    autoQueue: false,
    params: {
      opUpload: true,
      ws: $(".app-explorer").data("jalios-explorer-workspace-id")
    },
    uploadprogress: function (file, progress, bytesSent) {
      if (file.previewElement) {
        var progressElement = file.previewElement.querySelector(".dz-progress");
        progressElement.querySelector(".dz-upload").style.width = progress + "%";
        progressElement.querySelector(".progress-text").textContent = Math.round(progress) + "%";
      }
    },
    previewTemplate: document.querySelector("#template-container").innerHTML,
    previewsContainer: ".upload-previews-body",
    init: function () {
      this.on("addedfile", function (file) {
        bindUnload();
        $(".explorer-upload-tooltip").removeClass("is-displayed");

        if ($(this.element).hasClass("is-upload-forbidden")) {
          toastr.options = {
            positionClass: "toast-top-center"
          };
          toastr.error(explorerAppI18Nprops.cannotUploadInFolder);
          return;
        }
        file.accepted = true;
        this.enqueueFile(file);

        $(".upload-previews").addClass("is-displayed");

        initializeUploadCleaner();
        if (!file.type.startsWith("image")) {
          // Icons map is loaded from explorer-file-icons.jsp
          if (FILE_ICONS_MAP && FILE_ICONS_MAP.size > 0) {
            var fileIcon = FILE_ICONS_MAP.get(file.type);
            $(file.previewElement).find(".dz-image IMG").attr("src", fileIcon)
          }
        }
      });
      this.on("error", function (event, errorMessage, xhr) {
        $(event.previewElement).find(".dz-progress").remove();
      });
      this.on("queuecomplete", function (event) {

        $.plugin.ExplorerApp.toggleExplorerLoading();

        let formData = $.plugin.ExplorerApp.getExplorerFormData();
        formData.append("isFiltering", true);
        let object = $.plugin.ExplorerApp.getFormDataAsJsonObject(formData);

        $(".explorer-section-publications").refresh({
          isform: true,
          callback: function () {
            $.plugin.ExplorerApp.getExplorer().refreshNoResultDisplay();
            $.plugin.ExplorerApp.hideExplorerLoading();
            $.plugin.ExplorerApp.getExplorer().updateItemNumbers();
          },
          params: object
        });
      });
      this.on("success", function (event) {
        var uploadStatus = JSON.parse(event.xhr.response);
        if (uploadStatus.actionStatus === "ERROR") {
          $(event.previewElement).find(".dz-progress").remove();
          $(event.previewElement).find(".dz-error-message > SPAN").text(uploadStatus.message);
          $(event.previewElement).removeClass("dz-success").removeClass("dz-complete").addClass("dz-error");
        } else {
          var dataId = JSON.parse(event.xhr.response).data.dataId;
          var categoryId = JSON.parse(event.xhr.response).data.categoryId;
          $(event.previewElement).find(".dz-progress").remove();
          $(event.previewElement).attr("data-jalios-explorer-action", "selectItem");
          $(event.previewElement).attr("data-jalios-data-id", dataId);

          setTimeout(function () {
            $(event.previewElement).remove();
          }, 7000);
          $.plugin.ExplorerApp.triggerEvent("dndUpload", {
            "dataId": dataId,
            "categoryId": categoryId
          })
        }
      });
      this.on("dragover", function (event) {
        let $targetElement = $(event.toElement);
        if ($targetElement.hasClass("explorer-item-data")) {
          $targetElement = $targetElement.closest(".app-body");
        }

        if (!$targetElement.hasClass("explorer-item-category") && !$targetElement.hasClass("is-dropzone-initialized")) {
          $targetElement = $targetElement.closest(".is-dropzone-initialized");
        }

        if ($targetElement.exists()) {
          $targetElement.addClass("is-upload-over");

          // TOOLTIP
          let isForbiddenUpload = $targetElement.hasClass("is-upload-forbidden");
          if (isForbiddenUpload) {
            $(".explorer-upload-tooltip").addClass("is-forbidden");
            //$(".explorer-upload-tooltip-category").text($.jalios.I18N.glp("jcmsplugin.explorer.app.info.upload-forbidden"));
          } else {

          }
          if ($targetElement.closest(".explorer-item-category").exists() || $targetElement.hasClass("sidebar-categorytree-item-link")) {
            $(".explorer-upload-tooltip-category").text($targetElement.find(".js-title").text());
          } else {
            $(".explorer-upload-tooltip-category").text($.plugin.ExplorerApp.isCurrentCategoryRoot() ? $.plugin.ExplorerApp.getCurrentCategoryName() : $.plugin.ExplorerApp.getCurrentCategoryName());
          }

          $(".explorer-upload-tooltip").addClass("is-displayed");
        }
      });
      this.on("dragleave", function (event) {
        $(event.toElement).removeClass("is-upload-over");
        $(".explorer-upload-tooltip").removeClass("is-forbidden");
        $(".explorer-upload-tooltip").removeClass("is-displayed");
      });
    }
  }
  var dropzoneCommonParamsI18n;

  var bindUnload = function () {
    isUnloadBinded = true;
    window.onbeforeunload = function () {
      return "";
    }
  }

  var unbindUnload = function () {
    isUnloadBinded = false;
    window.onbeforeunload = null;
  }

  /**
   * The explorer uploader
   * @constructor
   * @typedef {Object} Explorer
   */
  var ExplorerUploader = function () {
    this.init();
    var uploaders = [];
    $.plugin.ExplorerApp.getExplorer().UPLOADER = this;
  };

  ExplorerUploader.prototype.init = function () {
    $.console.log("Initializing ExplorerUploader");
    initUploaderClickEvents();
    initDropzones();
    initUploaderEventHandlers();
  };

  ExplorerUploader.prototype.initAfterAjax = function () {
    $.console.log("Initializing ExplorerUploader after ajax refresh");
    initDropzones();
  };


  var initUploaderEventHandlers = function () {
    // Called when upload has been performed in current category to refresh publication list
    $.plugin.ExplorerApp.getExplorer().$element.on("jalios.explorer", function (event) {
      if (event.explorerEvent === "dndUpload" && event.explorerParams.categoryId === $.plugin.ExplorerApp.getExplorer().data.currentCategoryId) {
        // When current category gets new file, refresh the pub list
        // TODO : warning, currently a refresh is performed for each file, we should wait for all the files to finish
        $.plugin.ExplorerApp.toggleExplorerLoading();

        let formData = $.plugin.ExplorerApp.getExplorerFormData();
        formData.append("isFiltering", true);
        let object = $.plugin.ExplorerApp.getFormDataAsJsonObject(formData);

        // $(".explorer-section-publications").refresh({
        //   isform: true,
        //   callback: function() {
        //     $.plugin.ExplorerApp.hideExplorerLoading();
        //   },
        //   params: object
        // });
      }
    });
  };

  var initUploaderClickEvents = function () {
    $(document).on("click", ".close-preview", function (event) {
      $(".upload-previews").removeClass("is-displayed");
    });
  };

  var initMainDropzone = function () {
    // Kill existing if any
    if ($(".app-main.is-dropzone-initialized").exists() && $(".app-main.is-dropzone-initialized")[0].dropzone) {
      $(".app-main.is-dropzone-initialized")[0].dropzone.destroy();
      $(".app-main.is-dropzone-initialized").removeClass("is-dropzone-initialized");
    }

    // Current Category
    let uniqueDropzoneCustomParams = {
      params: {
        explorerCurrentCategory: $.plugin.ExplorerApp.getExplorer().data.currentCategoryId,
        portletExplorer: $.plugin.ExplorerApp.getExplorer().data.portletExplorerId
      }
    };
    if ($(".app-main:not(.is-dropzone-initialized)").exists()) {
      $.plugin.ExplorerApp.consoleDebugGroup("Initializing dropzone on main category", [
        "Current category id :" + $.plugin.ExplorerApp.getExplorer().data.currentCategoryId
      ]);
      let uniqueDropzoneParams = $.extend(true, {}, dropzoneCommonParamsWithCustom, uniqueDropzoneCustomParams);
      let uniqueDropzone = $(".app-main:not(.is-dropzone-initialized)").dropzone(uniqueDropzoneParams)[0].dropzone;
      tempUploaders.push(uniqueDropzone);
      $(".app-main").addClass("is-dropzone-initialized");
    }
  }

  var initCategoriesDropzones = function () {
    // Inner categories
    $(".explorer-item-category:not(.is-dropzone-initialized), .sidebar-categorytree-item:not(.is-dropzone-initialized)").each(function (
      index,
      element
    ) {
      let elementDropzoneCustomParams = {
        params: {
          explorerCurrentCategory: $(element).data("jalios-data-id"),
          portletExplorer: $.plugin.ExplorerApp.getExplorer().data.portletExplorerId
        }
      };
      let dropzoneParams = $.extend(true, {}, dropzoneCommonParamsWithCustom, elementDropzoneCustomParams);

      let elementDropzone = $(element).dropzone(dropzoneParams)[0].dropzone;
      tempUploaders.push(elementDropzone);

      $(element).addClass("is-dropzone-initialized");
    });
  }

  var initNoResultDropzone = function () {
    let $uploadFileBtn = $(".upload-file-btn");

    if (!$uploadFileBtn.exists()) {
      return;
    }

    let elementDropzoneCustomParams = {
      clickable: true,
      params: {
        explorerCurrentCategory: $uploadFileBtn.data("jalios-data-id"),
        portletExplorer: $.plugin.ExplorerApp.getExplorer().data.portletExplorerId
      }
    };

    let dropzoneParams = $.extend(true, {}, dropzoneCommonParamsWithCustom, elementDropzoneCustomParams);

    if ($uploadFileBtn.hasClass("is-dropzone-initialized") && $uploadFileBtn.dropzone(dropzoneParams)[0].dropzone) {
      $uploadFileBtn.dropzone(dropzoneParams)[0].dropzone.destroy();
    }

    let uniqueDropzone = $uploadFileBtn.dropzone(dropzoneParams)[0].dropzone;
    $uploadFileBtn.addClass("is-dropzone-initialized");
  }

  var initAddMenuDropzone = function () {
    let $uploadFileBtn = $(".add-menu-add-file");

    if (!$uploadFileBtn.exists()) {
      return;
    }

    let elementDropzoneCustomParams = {
      clickable: true,
      params: {
        explorerCurrentCategory: $uploadFileBtn.data("jalios-data-id"),
        portletExplorer: $.plugin.ExplorerApp.getExplorer().data.portletExplorerId
      }
    };

    let dropzoneParams = $.extend(true, {}, dropzoneCommonParamsWithCustom, elementDropzoneCustomParams);

    if ($uploadFileBtn.hasClass("is-dropzone-initialized") && $uploadFileBtn.dropzone(dropzoneParams)[0].dropzone) {
      $uploadFileBtn.dropzone(dropzoneParams)[0].dropzone.destroy();
    }

    let uniqueDropzone = $uploadFileBtn.dropzone(dropzoneParams)[0].dropzone;
    $uploadFileBtn.addClass("is-dropzone-initialized");
  }

  var initDropzones = function () {
    initCategoriesDropzones();
    initMainDropzone();
    initNoResultDropzone();
    initAddMenuDropzone();
  };

  var uploadCleaner;
  var initializeUploadCleaner = function () {
    uploadCleaner = setInterval(function () {
      if ($(".upload-previews-body .explorer-item-data.dz-error").length === 0 && $(".upload-previews-body .explorer-item-data:not(.dz-complete)").length === 0) {
        $(".upload-previews").removeClass("is-displayed");
        unbindUnload();
        clearInterval(uploadCleaner);
      }
    }, 3000);
  }

  $(document).ready(function () {
    // Load dropzone_custom_attributes found in file dropzone-custom-attributes.jsp
    if (dropzone_custom_attributes && Object.keys(dropzone_custom_attributes).length > 0) {
      dropzoneCommonParamsWithCustom = $.extend(true, {}, dropzoneCommonParams, dropzone_custom_attributes);
    } else {
      dropzoneCommonParamsWithCustom = dropzoneCommonParams;
    }
    
    $(document).on("keydown", ".add-menu-add-file", function(event) {
      event.preventDefault();
      let code = event.charCode || event.keyCode;
      if((code === 32)|| (code === 13)){
        $(event.currentTarget)[0].click();
      }
    })
    
    EXPLORER_UPLOADER = new ExplorerUploader();
    EXPLORER_UPLOADER.uploaders = tempUploaders;
    $.plugin.ExplorerApp.getExplorer().$element.on("jalios.explorer", function (event) {
      if (event.explorerEvent === "movedToCategory") {
        initDropzones();
      }
    });
  });

})(window.jQuery);
