!function ($) {
  
  /* Do stuff on DOM Ready */
  var register = function() {
    
      // Auto ajax-refresh on form change    
      $(document).on('change', 'DIV.explorer .ajax-refresh-onchange INPUT', function(event){
        // disable ajax-refresh trigger so all input values are sent
        // and not being replaced with only the value that was clicked
        $(this).refresh({trigger:false});        
      });
      $(document).on('change', 'DIV.explorer .ajax-refresh-onchange SELECT', function(event){
        $(this).refresh();
      });
      
      // Auto ajax-refresh on jalios:sortable event on fields order
      $(document).on('jalios:sortable', function(event){
        if (event.sortable && $(event.sortable.container).is('.ajax-refresh-onchange')) {
          $(event.sortable.container).find('input:checked').first().refresh({trigger:false});          
        }
      });
      

      $(document).on("jalios:refresh", function(event) {
        var refreshBefore = $.jalios.Event.match(event, 'refresh', 'before');
        var refreshAfter = $.jalios.Event.match(event, 'refresh', 'after');
        
        // Disable auto scroll to top when navigating in explorer categories
        if (refreshBefore && $(refreshBefore.options.trigger).hasClass('treeview-name') && $(refreshBefore.options.trigger).parents('DIV.ex-nav-treecat')){
          refreshBefore.options.noscroll = true;
        }
        
        // Caddy : replace add/remove operation with currently displayed publications
        if (refreshBefore && $(refreshBefore.options.trigger).hasClass('exa-caddy')){
          var $trigger = $(refreshBefore.options.trigger);
          // Remove the caddy auto update from the link
          $trigger.removeClass('caddyUpdate');
          // Find all publication being displayed by explorer
          var cadIds = $.unique($.map($(".exa-pub"), function(n,i){return $(n).getJcmsId();}));
          // Update the ajax caddy params and the DOM with thoses ids
          refreshBefore.options.params.cadIds = cadIds;
        }
        
        // EXPLORER-167 : Status bar is not updated upon empty category deletion
        // --> refresh whole explorer if any action (such as create/rename/delete) is triggered on a currently selected category  
        if (refreshAfter && !refreshAfter.options.target && refreshAfter.url === 'jcore/ctxmenu/ctxmenu.jsp' &&
            refreshAfter.options.params && refreshAfter.options.params['ctxId'] != null) {
          if (jQuery('.explorer input[name=exCids]').val().indexOf(refreshAfter.options.params['ctxId']) != -1) {
            jQuery('.explorer input[name=exCids]').refresh();
          }
        }
        
      });
    
      
      // Keep track of accordion/panel that have been opened
      var accordionStateCB = function(event) { 
        var $stateInput = $(event.target).find('INPUT.accordion-state');
        if ($stateInput.exists()) {
          $stateInput.val(('show' == event.type) ? 'show' : 'collapse');
          $stateInput.refresh();
        }
      }
      $(document).on('show.bs.collapse', 'DIV.explorer', accordionStateCB);
      $(document).on('hide.bs.collapse', 'DIV.explorer', accordionStateCB);
    
     // Track opened cids
      $(document).bind("ajaxSend", function( event, jqXHR, ajaxOptions ) {
          var ocids = jQuery('.ex-nav-treecat .treeview-open').map(function(idx, elm){
            var $elm = jQuery(elm);
            var isNotInClosedCategory = !$elm.closest('.treeview-close').exists();  
            return isNotInClosedCategory ? $elm.getJcmsId() : null;
          });
          var ocidsString = 'ocids,' + ocids.get().join(',');
          jqXHR.setRequestHeader( 'X-Jcms-Explorer-ocids', ocidsString);
      });
      
      // Preview action
      $(document).on('click', 'A.exa-preview', function (event) {
        
        var $link = $(event.currentTarget);
        var pubId = $link.getJcmsId();
        if (!pubId) {
          return;
        }
        
        var $explorer = $link.parents('DIV.explorer');
        var $exPreviewInput = $explorer.find('INPUT[name="exPreviewId"]');
        if ($link.hasClass("ex-preview-highlight")) {
          $exPreviewInput.val("empty"); 
        } else { 
          $exPreviewInput.val(pubId); 
        }
        $exPreviewInput.refresh();
        
        // Prevent click
        event.preventDefault();
        
        // Prevent propagation
        event.stopPropagation();
        
        // Prevent other handlers
        event.stopImmediatePropagation();
      });
      
      // Clear text
      $(document).on('click', 'BUTTON.exa-clear-text', function (event) {
        
        var $elm = $(event.currentTarget);
        var $explorer = $elm.parents('DIV.explorer');
        var $exText = $explorer.find('INPUT[name="exText"]');
        $exText.val('');
        $exText.refresh('');
        
      });
  }

  // ------------------------------------------
  //  DOM READY CODE
  // ------------------------------------------
  
  $(document).ready(function($) {
    register();
  }); 

}(window.jQuery);