/**
 * Load 30 new elements on each scroll
 *
 * Inspiration : 
 *  http://ajaxian.com/archives/endless-pageless-keep-scrolling-for-more-content
 *  http://cfsilence.com/blog/client/index.cfm/2007/10/24/Paging-Through-Records-OnScroll-Using-Unobtrusive-Spry
 */
!function ($) {
  
  /* Do stuff on DOM Ready */
  var register = function() {
    
    $('.ex-live-list').off('scroll', onLiveListScroll);
    $('.ex-live-list').on('scroll', onLiveListScroll);
      
  }
  
  var onLiveListScroll = function(){
    
    var $container = $(this);
    var scrollTop = $container.scrollTop();
    var clientHeight = $container[0].clientHeight;
    var scrollHeight = $container[0].scrollHeight;
    
    if (Math.round(scrollTop) + clientHeight == scrollHeight) {
      
      var liveListEndReached = $container.data('ex-live-list-end-reached');
      if (liveListEndReached) {
        return;
      }

      var $liveListBody = $container.find('.ex-live-list-body');
      var itemNbrBeforeRefresh = $liveListBody.find('tr').length;
      var livelistStart = $container.data('ex-live-list-start') || itemNbrBeforeRefresh;
      
      var url = 'plugins/ExplorerPlugin/jsp/viewmode/livelist/livelist-ajax.jsp';
      var ajaxParameters = { 
        exAjax: true, 
        exLiveListStart: livelistStart
      };
      
      $.console.info('refresh', url, ajaxParameters);
      $.jalios.AjaxRefresh.refresh(url, $liveListBody, { 
          'noscroll': true,
          'append': true, 
          'params': ajaxParameters,
          'callback': function($target, html) {
            var itemNbr = jQuery($target).find('tr').length;
            $container.data('ex-live-list-start', itemNbr);
            if (itemNbr == itemNbrBeforeRefresh) {
              $container.data('ex-live-list-end-reached', true);
            }
          }            
        });
    }
  }

  // ------------------------------------------
  //  DOM READY CODE
  // ------------------------------------------
  
  $(document).ready(function($) {
    register();
  }); 
  $(document).on('jalios:refresh', register);

}(window.jQuery);
