<%@page import="com.jalios.jcmsplugin.explorer.app.ExplorerAppManager"%>
<%@ include file='/plugins/ExplorerPlugin/jsp/app/sidebar/tabs/doInitExplorerAppSidebarTabContent.jspf' %>
<div class="tab-content-informations">
  <h3 class="sidebar-tab-title"><%= glp("jcmsplugin.explorer.app.sidebar-tab.informations") %></h3>

  <jalios:include target="EXPLORER_SIDEBAR_INFORMATIONS_TAB_1" />

  <% if (data instanceof Publication && isLogged) { %>
    <% Publication pub = (Publication) data; %>
    <% request.setAttribute("publication", pub); %>
    <div class="pub-action-toggler-<%= pub.getId() %> pub-pstatus-<%= pub.getPstatus() %>">
      <div class="selection-side">
        <% 
          if (Util.notEmpty(sidebarHandler.getExplorerUrl())) {
            request.setAttribute("PUBLICATION_ACTIONS_CUSTOM_REDIRECT", sidebarHandler.getExplorerUrl());
            request.setAttribute("PUBLICATION_ACTIONS_DELETE_REDIRECT", sidebarHandler.getExplorerUrl());
          }
        %>
        <jalios:include jsp="<%= ResourceHelper.getPublicationAction() %>"/>
      </div>
    </div>
  <% } %>
  
  <jalios:include target="EXPLORER_SIDEBAR_INFORMATIONS_TAB_2" />
  
  <% if (data instanceof Publication && ExplorerAppManager.getInstance().isSidebarCompatiblePublication((Publication) data)) { %>
    <jalios:include pub="<%= (Publication) data %>" />
  <% } else { %>
  
	  <% if (data instanceof Publication) { %>
	    <% Publication pub = (Publication) data; %>
		  <% request.setAttribute("publication", pub); %>
			<% boolean isMetaFileDocument = pub instanceof FileDocument; %>
			<jalios:include target="PUBLICATION_META_TOP_BEFORE" />
			<div class="publication-info">
			  <jalios:include target="PUBLICATION_META_TOP" />
			  <div class="publication-meta">
			    <% if (isMetaFileDocument) {
			      FileDocument metaDoc = (FileDocument) pub; 
			      
			      Member opAuthor = metaDoc.getOpAuthor();
			
			      boolean hasBeenUpdated = opAuthor != null && metaDoc.getCdate() != null && Math.abs(metaDoc.getMdate().getTime() - metaDoc.getCdate().getTime()) > 2000 ;
			      %>
			      
			      <% if (hasBeenUpdated) { %>      
			      <div class="filedocument-update">
			        <jalios:memberphoto css="meta-photo" member="<%= opAuthor %>" size="<%= PhotoSize.ICON %>" />
			        <%
			        String updatedBy;
			        if (!opAuthor.canBeReadBy(loggedMember)) {
			          updatedBy = glp("ui.com.lbl.restricted-mbr");
			        } else if (opAuthor.equals(pub.getAuthor())) {
			          updatedBy = opAuthor.getDisplayLink(userLocale);
			        } else {
			          updatedBy = "<span itemprop='contributor'>"+opAuthor.getDisplayLink(userLocale)+"</span>";
			        }
			        %>
			        <%= glp("ui.filedocument.lbl.updated-by", updatedBy) %>
			        &middot;
			        <meta itemprop="dateModified" content="<%= DateUtil.formatIso8601Date(metaDoc.getMdate()) %>" />
			        <%= JcmsUtil.getFriendlyDate(getZonedDateTime(metaDoc.getMdate()), java.time.format.FormatStyle.SHORT, true, userLocale) %>
			        <% if (pub.hasAnyReadRights()) { %>
			        &middot;      
			        <jalios:tooltip icon="key" longdesc='<%= "jcore/tooltip/ttPublicationRights.jsp?id="+pub.getId() %>' />
			        <% } %>
			        <% if (metaDoc.getPstatus() != WorkflowConstants.PUBLISHED_PSTATUS) { %>
			        &middot; <%= metaDoc.getWFStateLabelHtml(userLang) %>
			        <% } %>
			        &middot; <%= glp("ui.com.lbl.version") %> <%= metaDoc.getVersionString() %>            
			        <a role="button" aria-expanded="false" tabindex="0" data-jalios-action="toggle:hide toggle:dropup" data-jalios-target=".filedocument-create|this"><jalios:icon src="caret" alt="jcmsplugin.explorer.app.toggle-pub-metas" /></a>
			      </div>
			      <% } %>
			                    
			      <div class="filedocument-create <%= hasBeenUpdated ? "hide" : "" %>">
			        <jalios:memberphoto css="meta-photo" member="<%= pub.getAuthor() %>" size="<%= PhotoSize.ICON %>" />
			        <% if (pub.getAuthor() != null) { %>
			        <%= glp("ui.filedocument.lbl.uploaded-by", pub.getAuthor().canBeReadBy(loggedMember) ? ("<span itemprop='author'>"+pub.getAuthor().getDisplayLink(userLocale)+"</span>"): glp("ui.com.lbl.restricted-mbr")) %>
			        &middot; 
			        <% } %>
			        <meta itemprop="dateCreated" content="<%= DateUtil.formatIso8601Date(pub.getCdate()) %>" />
			        <%= JcmsUtil.getFriendlyDate(getZonedDateTime(pub.getCdate()), java.time.format.FormatStyle.SHORT, true, userLocale) %> 
			        <% if (pub.hasAnyReadRights()) { %>
			        &middot;      
			        <jalios:tooltip icon="key" longdesc='<%= "jcore/tooltip/ttPublicationRights.jsp?id="+pub.getId() %>' />
			        <% } %>
			        <% if (!hasBeenUpdated && metaDoc.getPstatus() != WorkflowConstants.PUBLISHED_PSTATUS) { %>
			        &middot; <%= metaDoc.getWFStateLabelHtml(userLang) %>
			        <% } %>
			      </div>
			
			    <% } else { %>
			      <div class="author-date-rights">
			        <jalios:memberphoto css="meta-photo" member="<%= pub.getAuthor() %>" size="<%= PhotoSize.ICON %>" />
			        <span itemprop="author"><jalios:link css="meta-author" data="<%= pub.getAuthor() %>" /></span>
			        &middot;
			        <meta itemprop="datePublished" content="<%= DateUtil.formatIso8601Date(pub.getPdate()) %>" />
			        <%= JcmsUtil.getFriendlyDate(getZonedDateTime(pub.getPdate()), java.time.format.FormatStyle.SHORT, true, userLocale) %>
			        <% if (pub.hasAnyReadRights()) { %>
			        &middot;      
			        <jalios:tooltip icon="key" longdesc='<%= "jcore/tooltip/ttPublicationRights.jsp?id="+pub.getId() %>' />
			        <% } %>
			      </div>
			      <%@ include file='/plugins/ExplorerPlugin/jsp/app/sidebar/tabs/doExplorerAppSidebarTab_PublicationCategories.jspf' %>
			    <% } %>
			  </div>
			  
			  <% if (isMetaFileDocument) { %>
			    <% FileDocument metaDoc = (FileDocument) pub; %>
			    <%@ include file='/front/publication/doFileDocumentMeta.jspf' %>
			    <%@ include file='/plugins/ExplorerPlugin/jsp/app/sidebar/tabs/doExplorerAppSidebarTab_PublicationCategories.jspf' %>
			  <% } %>
			  <jalios:include target="PUBLICATION_META_BOTTOM" />
			</div>
			<jalios:include target="PUBLICATION_META_BOTTOM_AFTER" />    
	         <% 
	   // Lock Info
	   boolean showLockInfo = isLogged && loggedMember.isWorker(pub.getWorkspace()) && pub.isStrongLocked();
	   if (showLockInfo) {
	     %><jalios:message><%
	     %><p><%= pub.getStrongLockInfo(userLocale) %></p>
	       <% if (channel.isDataWriteEnabled() && isLogged) { %>
	         <p>
	           <% if (pub.canRequestUnlock(loggedMember)) { %>
	             <a class='modal btn btn-default' href='work/requestUnlock.jsp?id=<%= pub.getId() %>'><%= glp("ui.work.alt.unlock-request") %></a>
	           <% } %>
	           <% if (loggedMember.canWorkOn(pub) && pub.isStrongLocked()) { %>
	             <a class="btn btn-default modal confirm" data-jalios-text="<%= glp("msg.js.confirm-unlock", HttpUtil.encodeForHTMLAttribute(pub.getTitle(userLang))) %>" href="edit.jsp?opUnlock=true&amp;id=<%= pub.getId() %>&amp;redirect=<%= ServletUtil.encodeURL(sidebarHandler.getExplorerUrl()) %>"><%= glp("ui.com.alt.unlock") %></a>
	           <% } %>
	         </p><%
	       } 
	     %></jalios:message>
	   <% }  %>  
	  <% } %>
	  
	
	  
	  <% if (data instanceof Publication && !(data instanceof FileDocument)) { %>
	    <% Publication pub = (Publication) data; %>
	    <%@ include file='/front/publication/doPublicationAbstract.jspf' %>
	  <% } %>
  <% } %><%-- EOF display full display --%>
  <%--
  @Summary: Sub-footer for display page
  @Deprecated: False
  @Customizable: True
  @Requestable: False
  @Summary: Sub-footer for display page
  @Category: Presentation
	--%><%
	boolean skipFooter = Util.toBoolean(request.getAttribute("skipFooter"),false);
	if(!skipFooter){
	%>
  <jalios:include target="EXPLORER_SIDEBAR_INFORMATIONS_TAB_3" />
	
	<div class="fulldisplay-footer br">
	<jalios:include jsp="/front/vote/doVoteFooter.jsp" />
	<%-- *** PLUGINS ***************** --%><%
	%>
	</div>
	<% } %>
  
  
  <% if (data instanceof FileDocument) { %>
    <% FileDocument doc = (FileDocument) data; %>
    <%-- MAIN ACTIONS --%>
    <div class="main-actions br hidden-print">
      <%-- Download --%>
      <% 
      String ariaLabel = encodeForHTMLAttribute(doc.getTitle(userLang)) + " - " + encodeForHTMLAttribute(doc.getTypeInfo(userLang));
      if (!doc.isRemote()) {
        ariaLabel += " - " + encodeForHTMLAttribute(Util.formatFileSize(doc.getSize(), userLocale, false));
      }
      %>
      <a class="btn btn-success" aria-describedby="sidebar-<%= sidebarHandler.getAvailablePortletExplorer().getId() %>" href="<%= doc.getDownloadUrl() %>" download="<%= encodeForHTMLAttribute(doc.getDownloadName(userLang)) %>" aria-label='<%= ariaLabel %>'><% if (!doc.isRemote()) { %><jalios:icon src="download-btn" /><% } %> <%= doc.isRemote() ? glp("ui.com.btn.access-doc") : glp("ui.com.btn.download")%></a>
    
      <%-- Reupload --%>
      <% if (isLogged && doc.canBeUploadedBy(loggedMember)) { %>
        <a class="btn btn-default" href="work/docChooser.jsp?id=<%= doc.getId() %>&amp;nbElt=1&amp;redirect=<%= encodeForURL(sidebarHandler.getExplorerUrlWithDisplayedPublicationParam()) %>" onclick="popupWindow(this.href, 'DocChooser_<%= doc.getId() %>', <%= JcmsConstants.DOCCHOOSER_WIDTH %>, <%= JcmsConstants.DOCCHOOSER_HEIGHT %>); return false;"><%= glp("ui.filedocument.lbl.update") %></a>
      <% } %>

      <%-- Edit With... --%>
      <%@ include file="/jcore/document/editDocumentWith.jspf" %>

      <jalios:include target="FILEDOCUMENT_MAIN_ACTIONS" targetContext="" />
      <a href="<%= doc.getDisplayUrl(userLocale) %>"  class="btn btn-default"><%= glp("jcmsplugin.explorer.action.access-pub") %></a>
    </div>  
  
    <%-- DESCRIPTION --%>
    <% if (Util.notEmpty(doc.getDescription(userLang))) { %>
    <div class="description">
      <jalios:wiki data="<%= doc %>" field="description"><%= doc.getDescription(userLang) %></jalios:wiki>
    </div>
    <% } %>
    
    <%-- TARGET --%>
    <jalios:include target="FILEDOCUMENT_FULLDISPLAY" targetContext="div" />
    
    <%-- PREVIEW --%> 
    <% if (ExplorerAppManager.getInstance().isSidebarPreviewDisplay(doc) && Util.toBoolean(request.getAttribute("fileDocumentPreview"),true)){ %>
	    <div class="preview">
		    <% if (doc.isRemote() && doc.previewRemoteWithIFrame()) { %>
		     <iframe src="<%= doc.getRemotePreviewUrl() %>" class="remote-document-preview"/>
		    <% } else { %>
		     <jalios:media fileDoc="<%= doc %>"/>
		    <% } %>
	    </div>
    <% } %>   
	  <jalios:include target="EXPLORER_SIDEBAR_INFORMATIONS_TAB_4" />
    
  <% } else { %>
    <div class="main-actions br hidden-print">
      <a href="<%= data.getDisplayUrl(userLocale) %>" class="btn btn-default"><%= glp("jcmsplugin.explorer.action.access-pub") %></a>
    </div>
  <% } %>
  <jalios:include target="EXPLORER_SIDEBAR_INFORMATIONS_TAB_5" />
</div>