<%--
  @Summary: Displays an explorer to the current user
  
--%><%@ page import="com.jalios.jcmsplugin.explorer.*" %><%
  request.setAttribute("inFO", Boolean.TRUE); // for bug EXPLORER-6, so that jcmsContext.getWorkspace() works correctly
%><%@ include file='/jcore/doInitPage.jspf' %><%--
--%><%@ include file='/jcore/portal/doPortletParams.jspf' %><%--
--%><%

  // Required CSS and JS
  jcmsContext.addCSSHeader("plugins/ExplorerPlugin/css/explorer.css");
  jcmsContext.addJavaScript("plugins/ExplorerPlugin/js/explorer.js");

  // See JavaDoc for more information on work performed by this java bean
  %><jsp:useBean id='explorerHandler' scope='page' class='com.jalios.jcmsplugin.explorer.ExplorerHandler'><%
    %><jsp:setProperty name='explorerHandler' property='pageContext' value='<%= pageContext %>'/><%
    %><jsp:setProperty name='explorerHandler' property='*' /><%
  %></jsp:useBean><%

  if (!explorerHandler.validate(true)) {
    return;
  }

  // Fix EXPLORER-88 : Access to the explorer from the back office triggers the browser print dialog
  {
    LinkedHashSet<String> jsCodeSet = jcmsContext.getJavaScriptCodeSet();
    if (jsCodeSet != null) {
      for (Iterator<String> codeIt = jsCodeSet.iterator(); codeIt.hasNext(); ) {
        String jsCode = codeIt.next();
        if (jsCode != null && jsCode.equals("window.print();")) {
          codeIt.remove();
          break;
        }
      }
    }
  }

  Explorer explorer = explorerHandler.getExplorer();
  ExplorerConfiguration exConfig = explorer.getConfiguration();
  QueryResultSet resultSet = explorer.getResultSet(); // This result set is computed for use by zip/caddy icon but may not be accurate as far as pagination params are concerned, "real request is in initView.jspf"

  // Add Explorer as a request attribute, needed for all dynamic includes below
  // attribute is removed at end of this jsp
  explorer.putInRequest(request);

  String displayURLparams = ((exConfig.getContextCategory() && currentCategory != null) ? "&amp;cid="+currentCategory.getId() : "") +
                            ((exConfig.getShowInCurrentPortal() && portal != null) ? "&amp;portal="+portal.getId() : "");
%>
<%@ include file='/jcore/doMessageBox.jspf' %>
<form name="<%= explorer.getId() %>Form" id="<%= explorer.getId() %>Form"
      action="plugins/ExplorerPlugin/jsp/doExplorer.jsp" method="get" class="responsive nosubmit-on-autocomplete ajax-refresh">
<div id="<%= explorer.getId() %>" class="explorer" data-jalios-ajax-refresh="isform">
  <input type="hidden" name="exId" value="<%= explorer.getId() %>" />
  <input type="hidden" name="exShowSidebar" value="<%= exConfig.isSidebarVisible() %>" />

  <%-- TOOLBAR --%>
  <div class="navbar navbar-default no-navbar-brand" role="navigation">
   <div class="container-fluid">
      <ul class="nav navbar-nav navbar-left">
      
        <%@ include file='/plugins/ExplorerPlugin/jsp/edittag.jspf' %> 

        <li class="dropdown">
          <a class="dropdown-toggle" data-toggle="dropdown" href="#" aria-expanded="false" aria-controls="<%= explorer.getId() %>-actions-menu">
           <jalios:icon src="actions"/> <%= glp("ui.com.lbl.actions") %> <jalios:icon src="caret"/>
          </a>
          <ul class="dropdown-menu" id="<%= explorer.getId() %>-actions-menu">
          <jalios:buffer name="explorerActionsMenuStartItems">
    <% 
    if (isLogged && 
        channel.getBooleanProperty("jcmsplugin.explorer.download-zip.enabled", true) && 
        exConfig.isRefiningOnDocument()) { 
       final int maxFileNbr = channel.getIntegerProperty("jcmsplugin.explorer.download-zip.max-file-nbr", 1000);
       
       if (Util.notEmpty(resultSet) && resultSet.getResultSize() <= maxFileNbr) {
         String docsParam = JcmsUtil.dataListToString(resultSet, ",");
         %>
             <li>
             <a href="plugins/ExplorerPlugin/jsp/downloadZipModal.jsp?ids=<%= encodeForURL(docsParam) %>&amp;redirect=<%= encodeForURL(explorer.getLinkURL(false)) %>"
                class="modal" title="<%= encodeForHTMLAttribute(glp("jcmsplugin.explorer.download-zip")) %>">
              <jalios:icon src="zip" alt="zip"/> <%= glp("jcmsplugin.explorer.download-zip") %>
             </a>
             </li>
         <%         
       }
     }
     %> 
             <jalios:include target="PLUGIN_EXPLORER_TOOLBAR" />
    <%     
     if (channel.getBooleanProperty("jcmsplugin.explorer.caddy.enabled", true) && Util.notEmpty(resultSet)) {
       boolean caddyNotEmpty = (0 != Caddy.getCaddy(request).getPublicationListSize()); 
       List<Publication> fakePublicationList = Util.getArrayList(Util.getFirst(resultSet));
       if (resultSet.size() > 1) { Iterator<Publication> it = resultSet.iterator(); it.next(); fakePublicationList.add(it.next()); }%>
             <li><jalios:caddy action='add' collection="<%= fakePublicationList %>" displayLinkText="<%= true %>" css="exa-caddy" /></li>
           <% if (caddyNotEmpty) { %>
             <li><jalios:caddy action='remove' collection="<%= fakePublicationList %>" displayLinkText="<%= true %>" css="exa-caddy" /></li>
           <% } %> <%
     }
     %>
             </jalios:buffer>
             
            <% if (Util.notEmpty(explorerActionsMenuStartItems)) { %>
             <%= explorerActionsMenuStartItems %>
             <li role="separator" class="divider"></li>
            <% } %>
             
             <li>
               <a href='<%= ServletUtil.getResourcePath(request) %><%= ServletUtil.getUpdatedParams(request, new String[]{PortalManager.getActionParam(null, "exResetSettings")}, new String[]{"true"}, "ex") %>' 
                  class="exl-reset modal confirm" title="<%= encodeForHTMLAttribute(glp("jcmsplugin.explorer.reset.help")) %>">
                 <jalios:icon src="jcmsplugin-explorer-reset"/> <%= glp("jcmsplugin.explorer.reset") %>
               </a>
             </li>
             
             <li>
               <a href="<%= explorer.getLinkURL() %>" class="exl-getLink modal permalink" title="<%= glp("jcmsplugin.explorer.link.use") %>">
                 <jalios:icon src="jcmsplugin-explorer-link"/> <%= glp("jcmsplugin.explorer.link") %>
               </a>
             </li>
           </ul>
         </li>
         
         <jalios:include target="PLUGIN_EXPLORER_NAVBAR_LEFT" />
     
      </ul>
   

    <%-- SEARCH --%>
    <% if (exConfig.isSearchBoxVisible()) { %>
      <div class="nav navbar-form navbar-nav navbar-right">
        
        <div class="form-group">
         <div class="input-group jalios-input-group">
          <input type="text" class="form-control" value="<%= encodeForHTMLAttribute(exConfig.getUserQueryHandler().getText()) %>" 
                 name="exText" placeholder="<%= glp("ui.com.placeholder.search") %>" aria-label="<%= glp("ui.work.search.text.text") %>">
          <div class="input-group-btn">
            <% if (Util.notEmpty(exConfig.getUserQueryHandler().getText())) { %>
            <button type="button" name="opClearSearch" class="btn btn-default exa-clear-text" title="<%= glp("ui.com.alt.clear") %>">
              <jalios:icon src="clear" />
            </button>
            <% } %>
            <button type="submit" name="opSearch" class="btn btn-default ajax-refresh" title="<%= glp("ui.com.btn.search") %>">
              <jalios:icon src="search" />
            </button>
          </div>
         </div>
        </div>        
      </div>
    <% } %>
   
    <%-- VIEW --%>
    <% if (exConfig.canChangeViewMode()) { %>
    <ul class="nav navbar-nav navbar-right">
      <jalios:include target="PLUGIN_EXPLORER_NAVBAR_RIGHT" />
         
    <li class="dropdown">
      <a href="#" class="dropdown-toggle" data-toggle="dropdown" aria-expanded="false" aria-controls="<%= explorer.getId() %>-actions-menu">
        <jalios:icon src='<%= "jcmsplugin-explorer-view-mode-" + exConfig.getViewMode() %>' />
        <%= ExplorerUtils.getViewModeLabel(userLang, exConfig.getViewMode()) %> 
        <jalios:icon src="caret"/>
        </a>
      <ul class="dropdown-menu" id="<%= explorer.getId() %>-viewmode-menu">
       <jalios:foreach name='viewMode' type='String' collection='<%= exConfig.getAvailableViewModes() %>'>
        <li>
          <a href='<%= ServletUtil.getUrlWithUpdatedParam(request, "exViewMode", viewMode) %>' 
             class="ajax-refresh <% if (viewMode.equals(exConfig.getViewMode())) { %> active<% } %>">
            <jalios:icon src='<%= "jcmsplugin-explorer-view-mode-" + viewMode %>' />
            <%= ExplorerUtils.getViewModeLabel(userLang, viewMode) %>
          </a>
        </li>
       </jalios:foreach>
      </ul>
    </li>
    </ul>
    <% } %>
 

        

    
   </div><%-- /.container-fluid --%>
  </div><%-- navbar --%>
  
    <div class="ex-main row">
    
     <%-- SIDEBAR --%> 
     <% if (exConfig.isSidebarVisible()) { %>
     <div class="ex-sidebar col-md-3">
      
      <jalios:accordion multiOpen="true">
      
        <%-- CATEGORIES --%>
        <% if (!"hide".equals(exConfig.getNavigationState())) { %>
        <jalios:accordion-panel title="ui.com.lbl.categories" active='<%= "show".equals(exConfig.getNavigationState()) %>'>
          <input type="hidden" name="exNavigationState" value="<%= exConfig.getNavigationState() %>" class="accordion-state"/>
          <%@ include file='/plugins/ExplorerPlugin/jsp/navigation.jspf' %>
        </jalios:accordion-panel>
        <% } %>
        
        <%-- SEARCH --%>
        <% if (!"hide".equals(exConfig.getSearchOptionsState())) { %>
        <jalios:accordion-panel title="jcmsplugin.explorer.search-opt" active='<%= "show".equals(exConfig.getSearchOptionsState()) %>'>
          <input type="hidden" name="exSearchOptionsState" value="<%= exConfig.getSearchOptionsState() %>" class="accordion-state"/>
  	      <%@ include file='/plugins/ExplorerPlugin/jsp/search.jspf' %>
        </jalios:accordion-panel>
        <% } %>
  		
        <%-- FIELDS --%>
        <% if (!"hide".equals(exConfig.getFieldsState())) { %>
        <jalios:accordion-panel title="jcmsplugin.explorer.fields" active='<%= "show".equals(exConfig.getFieldsState()) %>'>
          <input type="hidden" name="exFieldsState" value="<%= exConfig.getFieldsState() %>" class="accordion-state"/>
          <%@ include file='/plugins/ExplorerPlugin/jsp/fields.jspf' %>
        </jalios:accordion-panel>
        <% } %>
  
        <jalios:include target="PLUGIN_EXPLORER_SIDEBAR" />
      
      </jalios:accordion>
      
     </div>
     <% } %>
     
     <%-- CONTENT --%>
     <div class="ex-content <%= exConfig.isSidebarVisible() ? "col-xs-12 col-sm-12 col-md-9" : "col-xs-12 col-sm-12 col-md-12" %>">
  
      <div class="panel panel-default">
       <div class="panel-body">
        <%-- PUBLICATIONS --%>
    		<div id="<%= explorer.getId() %>Pubs" class="ex-pubs">
    		  <jalios:include jsp="<%= explorer.getViewModeJsp() %>" />
    		</div>
     
        <%-- PREVIEW --%>
        <% if (channel.getBooleanProperty("jcmsplugin.explorer.use-preview", true)) { %>
        <div id="<%= explorer.getId() %>Preview" class="ex-preview">
    		  <%@ include file='/plugins/ExplorerPlugin/jsp/preview.jspf' %>
        </div>
        <% } %>
       </div><%-- panel-body --%>
       
       <div class="panel-footer">
        <%-- STATUS BAR --%>
        <div id="<%= explorer.getId() %>StatusBar" class="ex-statusbar">
         <%@ include file='/plugins/ExplorerPlugin/jsp/statusbar.jspf' %>
        </div>
       </div><%-- panel-footer --%>
       
      </div><%-- panel --%>
      
     </div><%-- col-md- --%>
     
   </div><%-- row --%>
 
 <%--
   When explorer is used in collaborative space, a "portlet" param is used to track the active tab :
   make sure this param is always kept in form submit / ajax refresh to ensure proper tab is displayed.
 --%>
  <input type="hidden" name="portlet" value="<%= encodeForHTMLAttribute(getUntrustedStringParameter("portlet", "")) %>" />
</div>
</form>
<%
  explorer.removeFromRequest(request);
%>
<%@ include file='/jcore/doAjaxFooter.jspf' %>