<%@ page import="org.apache.commons.io.FileUtils" %><%
%><%@ page import="org.apache.commons.io.IOUtils" %><%
%><%@ page import="java.util.Set" %><%
%><%@ page import="java.util.HashSet" %><%
%><%@ page import="java.io.File" %><%
%><%@ page import="java.io.BufferedOutputStream"%><%
%><%@ page import="com.jalios.jcms.analytics.AnalyticsManager" %><%
%><%@ page import="com.jalios.jcms.analytics.EventData" %><%
%><%@ page import="com.jalios.jcms.tracking.ReaderTracker" %><%
%><%@ page import="com.jalios.jcms.servlet.BinaryFileServlet" %><%
%><%@ page import="com.jalios.jcms.FileDocument" %><%
%><%@ page import="java.util.LinkedList" %><%
%><%@ page import="java.text.*, com.jalios.io.*, java.util.zip.*" %><%    
%><%@ include file="/jcore/doInitPage.jspf" %><%

  if (!isLogged || !channel.getBooleanProperty("jcmsplugin.explorer.download-zip.enabled", true)) {
    return;
  }

  // Retrieve files to download from "ids" parameter, apply read right verification and compute total size
  long totalFileSize = 0;
  LinkedList<FileDocument> docList = new LinkedList<FileDocument>();
  for (FileDocument doc : getDataListParameter("ids", FileDocument.class)) {
    if (doc == null || !doc.canBeReadBy(loggedMember)) {
      continue;
    }
    
    File file = doc.getFile();
    if (file == null || !file.exists()) {
      continue;
    }
    
    docList.add(doc);
    totalFileSize += doc.getSize();
  }
  
  if (Util.isEmpty(docList)) {
    return;
  }
  
  String errorRedirect = Util.getString(getValidHttpUrl("redirect"), "front/displayMessageBox.jsp");
  
  // Check maximum number of file authorized has not been reached, default limit to 50 files
  final int maxFileNbr = channel.getIntegerProperty("jcmsplugin.explorer.download-zip.max-file-nbr", 50);
  if (docList.size() > maxFileNbr) {
    setWarningMsgSession(glp("jcmsplugin.explorer.download-zip.max-file-nbr-exceeded", docList.size(), maxFileNbr), request);
    sendRedirect(errorRedirect, request, response);
    return;
  }
  
  // Check maximum file size authorized (for unzip files) has not been reached, default limit to 100MB
  final long maxFileSize = channel.getLongProperty("jcmsplugin.explorer.download-zip.max-file-size", 100 * 1024 * 1024);
  if (totalFileSize > maxFileSize) {
    setWarningMsgSession(glp("jcmsplugin.explorer.download-zip.max-file-size-exceeded", 
                             docList.size(), Util.formatFileSize(totalFileSize, userLocale), Util.formatFileSize(maxFileSize, userLocale)), request);
    sendRedirect(errorRedirect, request, response);
    return;
  }

  // Zip content into a temp file
  final File tempFile = File.createTempFile("JaliosExplorerZipDownload.", (loggedMember != null ? ("." + loggedMember.getId()) : "") + ".zip");
  ZipOutputStream zos = null;
  try {    
    zos = new ZipOutputStream(new BufferedOutputStream(new FileOutputStream(tempFile)));
    
    // Track name of files already added to handle duplicate
    final Set<String> filenameSet = new HashSet<String>();
    
    for (FileDocument doc : docList) {
      final File file = doc.getFile();

      // Find proper filename, adding counter if title are the same
      final String filenameInArchive;
      {
        final String filenameInArchiveSrc = Util.getString(JcmsUtil.unescapeHtml(doc.getTitle(userLang)), file.getName()).replaceAll("[\\\\/]", " ");
        final String filenameExtensionSrc = IOUtil.getExtension(file);
        String filenameInArchiveTmp = filenameInArchiveSrc + "." + filenameExtensionSrc;
        int duplicateSuffix = 1; 
        while (filenameSet.contains(filenameInArchiveTmp)) {
          filenameInArchiveTmp = filenameInArchiveSrc + " (" + duplicateSuffix + ")." + filenameExtensionSrc;
          duplicateSuffix++;
        }
        filenameInArchive = filenameInArchiveTmp;
        filenameSet.add(filenameInArchive);
      }
      
      try {
        ZipEntry zipEntry = new ZipEntry(filenameInArchive);
        zipEntry.setTime(file.lastModified());
        zos.putNextEntry(zipEntry);
        FileUtils.copyFile(file, zos);
        zos.closeEntry();
      } catch (Exception ex){
        logger.warn("Exception while zipping '"+file+"' : " + ex.getMessage(), ex);
      }
      
      // EXPLORER-114 : Update each filedocument statistics and reader tracker during zip download
      // ReaderTracker
      doc.trackReader(loggedMember, ReaderTracker.ACCESS_TYPE_DOWNLOAD);
      // Statistics
      EventData eventData = new EventData(AnalyticsManager.DOWNLOAD, loggedMember, -1, doc);
      AnalyticsManager.appendEventData(eventData);
    }

    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd_HH-mm-ss");
    String zipName = Util.buildID(channel.getName()) + "_Files_" + sdf.format(new Date()) + ".zip";
    
    BinaryFileServlet.DownloadTicket ticket = new BinaryFileServlet.DownloadTicket(tempFile, "application/zip", zipName);
    ticket.setDeleteFileAfterDelivery(true);
    ticket.setUsePragmaNoCache(true);
    ticket.sendToDownloadUrl(request, response);    
  }
  finally {
    if (zos != null) {
      zos.close();      
    }
  }
  
  
%>