<%@page import="com.jalios.jcmsplugin.explorer.ExplorerConfiguration"%>
<%@page import="com.jalios.jcmsplugin.explorer.Explorer"%>
<%@ page import="com.jalios.jcms.servlet.BinaryFileServlet" %><%
%><%@ page import="com.jalios.jcms.FileDocument" %><%
%><%@ page import="java.util.LinkedList" %><%
%><%@ page import="java.text.*, com.jalios.io.*, java.util.zip.*" %><%    
%><%@ include file="/jcore/doInitPage.jspf" %><%

  if (!isLogged || !channel.getBooleanProperty("jcmsplugin.explorer.download-zip.enabled", true)) {
    return;
  }

 // 1. Retrieve result
 // 1.1 from explorer in ajax if possible
 final Explorer explorer = Explorer.getFromAjaxRequest(jcmsContext);
 final LinkedList<FileDocument> docList = new LinkedList<FileDocument>();
 if (explorer != null) {
   final ExplorerConfiguration exConfig = explorer.getConfiguration();
   final int startBackup = exConfig.getStart();
   final boolean pagerAllBackup = exConfig.getPagerAll();   
   exConfig.setStart(0);
   exConfig.setPagerAll(true);
   final QueryResultSet qrs = explorer.getResultSet();
   final SortedSet<Publication> pubSet = qrs.getAsSortedSet(ComparatorManager.getComparator(Publication.class, exConfig.getSort()));
   for (Publication pub : pubSet) {
     if (pub instanceof FileDocument) {       
       docList.add((FileDocument) pub);
     }
   }
   exConfig.setStart(startBackup);
   exConfig.setPagerAll(pagerAllBackup);
 } 
 // 1.2 or using request parameter 
 // Retrieve files to download from "ids" parameter, apply read right verification and compute total size
 else if (hasParameter("ids")) {
  for (FileDocument doc : getDataListParameter("ids", FileDocument.class)) {
    if (doc == null || !doc.canBeReadBy(loggedMember)) {
      continue;
    }
    docList.add(doc);
  }
 }
 
 // 2. Cleanup doclist (remove missing file) and compute totalFileSize
 long totalFileSize = 0;
 for (Iterator<FileDocument> docIt = docList.iterator(); docIt.hasNext();) {
   FileDocument doc = docIt.next();
   
   File file = doc.getFile();
   if (file == null || !file.exists()) {
     docIt.remove();
     continue;
   }
   
   totalFileSize += doc.getSize();
 }
    
 
  if (Util.isEmpty(docList)) {
    return;
  }
  
  String errorRedirect = Util.getString(getValidHttpUrl("redirect"), "front/displayMessageBox.jsp");
  
  String warningMsg = null;
  
  // Check maximum number of file authorized has not been reached, default limit to 50 files
  final int maxFileNbr = channel.getIntegerProperty("jcmsplugin.explorer.download-zip.max-file-nbr", 50);
  if (docList.size() > maxFileNbr) {
    warningMsg = glp("jcmsplugin.explorer.download-zip.max-file-nbr-exceeded", docList.size(), maxFileNbr);
  }
  
  // Check maximum file size authorized (for unzip files) has not been reached, default limit to 100MB
  final long maxFileSize = channel.getLongProperty("jcmsplugin.explorer.download-zip.max-file-size", 100 * 1024 * 1024);
  if (totalFileSize > maxFileSize) {
    warningMsg = glp("jcmsplugin.explorer.download-zip.max-file-size-exceeded", 
                             docList.size(), Util.formatFileSize(totalFileSize, userLocale), Util.formatFileSize(maxFileSize, userLocale));
  }

  if (warningMsg != null) { %>
<jalios:modal css="modal-md alert">
  <h3><%= glp("ui.com.lbl.alert") %></h3>
  <p><%= warningMsg %></p>
</jalios:modal>
<% } else { 
  String docsParam = JcmsUtil.dataListToString(docList, ",");
  String redirectUrl = getValidHttpUrl("redirect");
  String downloadUrl = ServletUtil.getBaseUrl(request) + 
                       "plugins/ExplorerPlugin/jsp/downloadZip.jsp?ids=" + encodeForURL(docsParam) +
                       "&amp;redirect=" + encodeForURL(redirectUrl);
%>
<jalios:modal css="modal-md" title="ui.com.lbl.confirm">
  <jalios:message level="<%= MessageLevel.INFO %>"><%= glp("jcmsplugin.explorer.download-zip.confirm", docList.size(), Util.formatFileSize(totalFileSize, userLocale)) %></jalios:message>
  <jalios:list>
   <% 
   int counter = 0; 
   for (FileDocument doc : docList) {
     counter++;
     if (counter >= 10) {
       %><jalios:listItem text="..."/><%
      break;
     } 
   %>  
   <jalios:dataListItem data="<%= doc %>" >
     <jalios:buffer name="LIST_ITEM_META"><jalios:filesize doc='<%= doc %>'/></jalios:buffer>
   </jalios:dataListItem>
   <% } %>
  </jalios:list>
  
  <jalios:buffer name='MODAL_BUTTONS'>
    <button type="button" class="btn btn-default" data-dismiss="modal">
      <%= glp("ui.com.lbl.no") %>
    </button>
    <button type="submit" class="btn btn-primary focus" data-dismiss="modal"
            onclick="document.location.href='<%= encodeForJavaScript(downloadUrl) %>';">
      <%= glp("ui.com.lbl.yes") %>
    </button> 
  </jalios:buffer>
</jalios:modal>
<% } %>