<%--
  @Summary: Displays Explorer's publications in an icon view.
  
--%><%@ include file='/plugins/ExplorerPlugin/jsp/initView.jspf' %>

<%@ include file='/plugins/ExplorerPlugin/jsp/dropzone.jspf' %>
<%@ include file='/plugins/ExplorerPlugin/jsp/spellsuggest.jspf' %>
  
<div class="ex-pubs-icons row">

  <% boolean previewPubInDisplayedResults = false; %>
  <jalios:foreach name='itPub' type='Publication' collection='<%= sortedResultSet %>' counter='exCounter'
                  max='<%= exPagerHandler.getPageSize() %>' skip='<%= exPagerHandler.getStart() %>'>
  <%
    boolean isPreviewedPub = JcmsUtil.isSameId(itPub, explorer.getPreviewedPub());
    if (isPreviewedPub) {
      previewPubInDisplayedResults = true;
    }
  %>
  <div class="exa-pub ID_<%= JcmsUtil.getId(itPub) %> item col-xs-6 col-md-3">
  
    <div class="thumbnail <%= isPreviewedPub ? " ex-preview-highlight" : "" %>">
      <div class="badge"><%= exPagerHandler.getStart() + exCounter.intValue() %></div> 
      <jalios:link data='<%= itPub %>' css='<%= explorer.getPreviewLinkCss(itPub) %>'
                   title='<%= itPub.getTitle(userLang) %>' params='<%= displayURLparams %>'>

         <%-- Icon --%>
         <jalios:thumbnail data='<%= itPub %>' css="media-object"
                           width='<%= JcmsConstants.THUMBNAIL_LARGE_WIDTH %>'
                           square='true'>
           <jalios:icon src="<%= itPub.getGenericThumbnail() %>" css="media-object generic-thumbnail img-responsive" />
         </jalios:thumbnail>
         
      </jalios:link>
         
      <div class="caption">
         <h3>
           <jalios:link data='<%= itPub %>' css='<%= explorer.getPreviewLinkCss(itPub)%>' params='<%= displayURLparams %>'>
             <%= itPub.getTitle(userLang) %>
           </jalios:link>
         </h3>
      </div>
    </div>    
  </div>
  </jalios:foreach>
  <% request.setAttribute("jcmsplugin.explorer.previewed-pub-in-displayed-results", previewPubInDisplayedResults); %>

</div>

  <jalios:pager name='exPagerHandler'/>
  
<%@ include file='/jcore/doAjaxFooter.jspf' %>