<%--
  @Summary: Portlet Explorer display page
--%><%--
--%><%@ page import="com.jalios.jcmsplugin.explorer.*" %><%--
--%><%@ include file='/jcore/doInitPage.jspf' %><%--
--%><%@ include file='/jcore/portal/doPortletParams.jspf' %><%--
--%><% PortletExplorer box = (PortletExplorer) portlet;  %><%--
--%><%@ include file='/types/PortletQueryForeach/doQueryHandlers.jspf' %><%--
--%><%

  // Fix for both EXPLORER-50 & EXPLORER-75
  // Override a default behavior of doQueryHandlers.jspf which has been initially conceived for PQF never returning invisible pub : 
  //  Do NOT use _default visible pstatus_ if the _pstatus_ field was not specified in the box query
  String[]   boxQueries = (String[]) box.getFieldValue(jcmsContext, "queries"); // box.getQueries();
  boolean showInvisible = Util.arrayContains(box.getSearchIn(), "invisibles");
  
  // If no query was specified in PortletExplorer, and thus no QueryHandler was computed in doQueryHandlers.jspf,
  // use a default query and ensure a valid QueryHandler is used. This will prevent bug such as DEVEXPLORER-15
  if (Util.isEmpty(boxQueries) && Util.isEmpty(queryHandlerSet)){
    boxQueries = new String[] { "types=com.jalios.jcms.Content" };
    com.jalios.jcms.handler.QueryHandler handler = new com.jalios.jcms.handler.QueryHandler(boxQueries[0], request);
    handler.setAttribute(QueryFilter.PORTLET_QUERY, Boolean.TRUE); 
    handler.setSearchInDB(box.getSearchInDB());
    handler.setLoggedMember(loggedMember);
    handler.setResponse(response);
    queryHandlerSet.add(handler);
  }
  
  if (Util.notEmpty(boxQueries)){
    // Rebuild a list of "raw" QueryHandler based on box queries
    List<com.jalios.jcms.handler.QueryHandler> queryHandlerList = new LinkedList<com.jalios.jcms.handler.QueryHandler>();
    for (int i = 0 ; i < boxQueries.length ; i++){      
      String queryString = boxQueries[i];
      if (Util.isEmpty(queryString)) {
        continue;
      }
      com.jalios.jcms.handler.QueryHandler handler = new com.jalios.jcms.handler.QueryHandler(queryString, request);
      queryHandlerList.add(handler);
    }
    // overwrite pstatus computed in doQueryHandlers.jspf with the raw pstatus of the box queries
    int qhIdx = 0;
    for (com.jalios.jcms.handler.QueryHandler handler : (Set<com.jalios.jcms.handler.QueryHandler>) queryHandlerSet) {
      com.jalios.jcms.handler.QueryHandler unforcedHandler = queryHandlerList.get(qhIdx);
      handler.setPstatus(unforcedHandler.getPstatus());
      handler.setCheckPstatus(!showInvisible);
      qhIdx++;
    }
  }


  // ------------------------------------------------------------------------
  // ExplorerConfiguration is :
  //  - either retrieved from previous configuration saved in session (for this portlet),
  //    unless the PortletExplorer has been modified since the time the configuration was saved in session (Fix EXPLORER-37). 
  //  - or else created
  final ExplorerConfiguration exConfig;
  String savedConfigAttrName = "PortletExplorer." + box.getId() + ".SavedExplorerConfiguration.";
      
  // Fix EXPLORER-63 : user refinement is incorrectly kept accross workspaces when same portlet explorer is used
  // -> Consider that if same portlet is used accross several workspace, the refine category option 
  //    is enabled, in such case, use a custom explorer configuration per workspace
  if (box.getRefineCategory() && ("CurrentWS".equals(box.getRefineQueries()) || "CurrentWSCat".equals(box.getRefineQueries()))) {
    savedConfigAttrName += "." + workspace.getId();
  }      
      
  final Date boxMDate = (Date) session.getAttribute(savedConfigAttrName + "mdate");
  final boolean resetExplorer = Util.notEmpty(PortalManager.receiveAction(request, null, "exResetSettings"));
  final boolean invalidateSavedConfig =  HttpUtil.hasParameter(request, "historyRevertToInitialState") || resetExplorer || (boxMDate != null && !boxMDate.equals(box.getMdate()));
  
  final ExplorerConfiguration savedConfig = invalidateSavedConfig ? null : (ExplorerConfiguration) session.getAttribute(savedConfigAttrName);
  final boolean updateConfig = (savedConfig == null);
  exConfig = (savedConfig != null) ? savedConfig : new ExplorerConfiguration();
  session.setAttribute(savedConfigAttrName, exConfig);
  session.setAttribute(savedConfigAttrName + "mdate", box.getMdate());
  
  if (logger.isTraceEnabled()) {
    logger.trace("invalidateSavedConfig:" + invalidateSavedConfig);
    logger.trace("updateConfig:" + updateConfig);
  }
  
  // ------------------------------------------------------------------------
  // Query
  exConfig.setSearchInDB(box.getSearchInDB());
  exConfig.setQueryHandlerSet(queryHandlerSet);

  // ------------------------------------------------------------------------
  // Navigation options

  // -- Root categories
  Set rootCategorySet = new HashSet();

  // Use refine categories which are descendant of selected categories in portlet
  if (box.getRefineCategory()) {
    if (logger.isDebugEnabled()) {
      logger.debug("Refining explorer root categories from queries refine option '" + box.getRefineQueries() + "'");
    }
    // Determine refine categories if any
    Set refineCategorySet = null;
	  if ("Portal".equals(box.getRefineQueries()) ||
	      "PortalExact".equals(box.getRefineQueries())) {
	    refineCategorySet = Util.getHashSet(portalCategory);
	  } else if ("Current".equals(box.getRefineQueries()) ||
	             "CurrentExact".equals(box.getRefineQueries())) {
	    refineCategorySet = Util.getHashSet(currentCategory);
	  } else if ("CurrentWS".equals(box.getRefineQueries()) || 
	             "CurrentWSCat".equals(box.getRefineQueries())) {
	    refineCategorySet = workspace.getCatSet();
	  }   
	  if (Util.notEmpty(refineCategorySet)) {
	    Set portletRootCategorySet = box.getRootCategories(loggedMember);
	    if (Util.isEmpty(portletRootCategorySet)) {
	      portletRootCategorySet = new HashSet();
	      portletRootCategorySet.add(SITEMAP_ROOT);
	    }
	    for (Iterator itPortletCat = portletRootCategorySet.iterator(); itPortletCat.hasNext(); ) {
	      Category portletCat = (Category) itPortletCat.next();
	      boolean portletCatWasRefined = false;
	      // Find if any refinement category is a descendant of current portlet category.
	      for (Iterator itRefineCat = refineCategorySet.iterator(); itRefineCat.hasNext(); ) {
	        Category refineCat = (Category) itRefineCat.next();
	        if (portletCat == refineCat || portletCat.containsDescendant(refineCat)) {
	          rootCategorySet.add(refineCat);
	          if (logger.isDebugEnabled()) {
	            logger.debug("- refineCat: " + refineCat);
	          }
	          portletCatWasRefined = true;
	        }
	      }
	      // If current portlet category was not refined, add it as is
	      if (!portletCatWasRefined) {
	        if (logger.isDebugEnabled()) {
	          logger.debug("- portletCat: " + portletCat);
	        }
          rootCategorySet.add(portletCat);
        }
	    }
	  }
  }
  
  // If category refinement was not requested *or if there was no refine category*, use specified portlet categories
  if (!box.getRefineCategory() || Util.isEmpty(rootCategorySet)) {
    Set portletRootCategorySet = box.getRootCategories(loggedMember);
    if (Util.notEmpty(portletRootCategorySet)) {
      rootCategorySet.addAll(portletRootCategorySet);
    }
  }
  if (logger.isDebugEnabled()) {
    logger.debug("RootCategorySet: [" + Util.join(rootCategorySet, ", ") + "]");
  }
  exConfig.setRootCategorySet(rootCategorySet);
  
  // -- Exact Category
  if (updateConfig && box.getExactCat() && rootCategorySet.size() == 1) {
    exConfig.setRefineCategories(rootCategorySet);
  }
  if (updateConfig) {
    exConfig.getUserQueryHandler().setExactCat(box.getExactCat());
  }
  
  // ------------------------------------------------------------------------
  // Query / Refinement options

  // -- Sort order 
  if (updateConfig && Util.notEmpty(box.getOrderBy())) {
    exConfig.setSort(box.getOrderBy());
  }
  
	// -- Search in files
  exConfig.setAllowSearchInFiles(Util.arrayContains(box.getAuthorizedChanges(), "files")); 
  // Fix bug EXPLORER-67 : Search in attached files option is not applied correctly
  // searchInFiles settings of server side queries
  // was lost on each JSP invokation due to exConfig.setQueryHandlerSet(queryHandlerSet) above
  // --> Always force server side query of ExplorerConfig with the portlet configuration  
  boolean searchInFiles = Util.arrayContains(box.getSearchIn(), "files");  
  for (com.jalios.jcms.handler.QueryHandler handler : exConfig.getQueryHandlerSet()) {
    handler.setSearchInFiles(searchInFiles);
  }
  // --> Set "SearchInFiles" option of the user query only when update required 
  if (updateConfig) {
    exConfig.getUserQueryHandler().setSearchInFiles(searchInFiles); 
  }
  
  // -- Search in invisible pubs
  exConfig.setAllowCheckPstatusChange(Util.arrayContains(box.getAuthorizedChanges(), "invisibles"));
  if (updateConfig) {
    exConfig.setCheckPstatus(!showInvisible, false);
  }
  
  // ------------------------------------------------------------------------
  // Display Options
  
  exConfig.setAvailableViewModes(box.getAvailableViewModes()); 
  exConfig.setAllowViewModeChange(box.getAllowViewModeChange()); 

  if (updateConfig) { 
    
    exConfig.setShowInCurrentPortal(box.getShowInCurrentPortal());
    exConfig.setContextCategory(box.getContextCategory());
    
    exConfig.setViewMode(box.getDefaultViewMode());
    
    if (Util.notEmpty(box.getExplorerFields())) {
      exConfig.setFieldsList(Arrays.asList(box.getExplorerFields()));
    }
    
    exConfig.setShowSearchBox(box.getShowSearchBox()); 
    exConfig.setShowSidebar(box.getShowSidebar()); 
    exConfig.setNavigationState(box.getNavigationState()); 
    exConfig.setShowNavigationAdv(box.getShowNavigationAdv()); 
    exConfig.setSearchOptionsState(box.getSearchOptionsState());
    exConfig.setFieldsState(box.getFieldsState());
    exConfig.setShowUploadZone(box.getShowUploadZone());
    exConfig.setForceUploadZone(box.getForceUploadZone());

    exConfig.setPageSize(box.getMaxResults());
    exConfig.setPageSizes(box.getPageSizes());
    exConfig.setPagerAllLimit(box.getPagerAllLimit());
  }
  
  // ------------------------------------------------------------------------
  
  exConfig.putInRequest(request);
  
%><jalios:include jsp="/plugins/ExplorerPlugin/jsp/doExplorer.jsp" /><%

  exConfig.removeFromRequest(request);

%>